Rails.application.routes.draw do

  locales = Site.first.in_use_locales rescue I18n.available_locales
  
  	scope "(:locale)", locale: Regexp.new(locales.join("|")) do
		namespace :admin do
			get "/vlogs/get_temp_dir_name", to: 'vlogs#get_temp_dir_name'
			post "/vlogs/upload_temp_file", to: 'vlogs#upload_temp_file'
			post "/vlogs/clear_temp_dir", to: 'vlogs#clear_temp_dir'
			resources :vlogs
		end
		get "/xhr/vlogfiles/download" => "vlogs#download_file"
	end
end