module Vlog
  	class Engine < ::Rails::Engine
	    initializer "vlog" do 
		    OrbitApp.registration "Vlog", :type => "ModuleApp" do
			    module_label "vlog.vlog"
			    base_url File.expand_path File.dirname(__FILE__)
			    widget_methods ["widget"]
			    widget_settings [{"data_count"=>30}]
			    taggable "VLog"
			    categorizable
			    authorizable
			    frontend_enabled
			    data_count 1..30
			    side_bar do
		          head_label_i18n 'vlog.vlog', icon_class: "icons-camera"
		          available_for "users"
		          active_for_controllers (['admin/vlogs'])
		          head_link_path "admin_vlogs_path"

		          context_link 'vlog.all_vlogs',
		                                :link_path=>"admin_vlogs_path" ,
		                                :priority=>1,
		                                :active_for_action=>{'admin/vlogs'=>'index'},
		                                :available_for => 'users'
		          context_link 'new_', 
		                                :link_path=>"new_admin_vlog_path" ,
		                                :priority=>2,
		                                :active_for_action=>{'admin/vlogs'=>'new'},
		                                :available_for => 'sub_managers'
		          context_link 'categories',
		                                :link_path=>"admin_module_app_categories_path" ,
		                                :link_arg=>"{:module_app_id=>ModuleApp.find_by(:key=>'vlog').id}",
		                                :priority=>3,
		                                :active_for_action=>{'admin/vlogs'=>'categories'},
		                                :active_for_category => 'Vlog',
		                                :available_for => 'managers'
		          context_link 'tags',
		                                :link_path=>"admin_module_app_tags_path",
		                                :link_arg=>"{:module_app_id=>ModuleApp.find_by(:key=>'vlog').id}",
		                                :priority=>4,
		                                :active_for_action=>{'admin/vlogs'=>'tags'},
		                                :active_for_tag => 'Vlog',
		                                :available_for => 'managers'
		        end
		    end
		end
  	end
end
